package org.pnml.tools.epnk.diagram.part;

import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.gmf.runtime.notation.View;
import org.pnml.tools.epnk.diagram.edit.parts.ArcEditPart;
import org.pnml.tools.epnk.diagram.edit.parts.LabelProxyEditPart;
import org.pnml.tools.epnk.diagram.edit.parts.ObjectLabelproxyEditPart;
import org.pnml.tools.epnk.diagram.edit.parts.Page2EditPart;
import org.pnml.tools.epnk.diagram.edit.parts.PageEditPart;
import org.pnml.tools.epnk.diagram.edit.parts.PageLabelProxyEditPart;
import org.pnml.tools.epnk.diagram.edit.parts.PlaceEditPart;
import org.pnml.tools.epnk.diagram.edit.parts.RefPlaceEditPart;
import org.pnml.tools.epnk.diagram.edit.parts.RefTransitionEditPart;
import org.pnml.tools.epnk.diagram.edit.parts.TransitionEditPart;
import org.pnml.tools.epnk.diagram.providers.PNMLCoreModelElementTypes;
import org.pnml.tools.epnk.pnmlcoremodel.Arc;
import org.pnml.tools.epnk.pnmlcoremodel.LabelProxy;
import org.pnml.tools.epnk.pnmlcoremodel.Node;
import org.pnml.tools.epnk.pnmlcoremodel.Object;
import org.pnml.tools.epnk.pnmlcoremodel.Page;
import org.pnml.tools.epnk.pnmlcoremodel.PageLabelProxy;
import org.pnml.tools.epnk.pnmlcoremodel.Place;
import org.pnml.tools.epnk.pnmlcoremodel.PnmlcoremodelPackage;
import org.pnml.tools.epnk.pnmlcoremodel.RefPlace;
import org.pnml.tools.epnk.pnmlcoremodel.RefTransition;
import org.pnml.tools.epnk.pnmlcoremodel.Transition;

/**
 * @generated
 */
@SuppressWarnings("unchecked")
public class PNMLCoreModelDiagramUpdater {

	/**
	 * @generated
	 */

	public static List getSemanticChildren(View view) {
		switch (PNMLCoreModelVisualIDRegistry.getVisualID(view)) {
		case PageEditPart.VISUAL_ID:
			return getPage_1000SemanticChildren(view);
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated NOT
	 * @author eki
	 */
	public static List getPage_1000SemanticChildren(View view) {
		if (!view.isSetElement()) {
			return Collections.EMPTY_LIST;
		}
		Page modelElement = (Page) view.getElement();
		List result = new LinkedList();
		for (Iterator it = modelElement.getObject().iterator(); it.hasNext();) {
			Object childElement = (Object) it.next();
			int visualID = PNMLCoreModelVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == PlaceEditPart.VISUAL_ID) {
				result.add(new PNMLCoreModelNodeDescriptor(childElement,
						visualID));
				continue;
			}
			if (visualID == RefPlaceEditPart.VISUAL_ID) {
				result.add(new PNMLCoreModelNodeDescriptor(childElement,
						visualID));
				continue;
			}
			if (visualID == TransitionEditPart.VISUAL_ID) {
				result.add(new PNMLCoreModelNodeDescriptor(childElement,
						visualID));
				continue;
			}
			if (visualID == Page2EditPart.VISUAL_ID) {
				result.add(new PNMLCoreModelNodeDescriptor(childElement,
						visualID));
				continue;
			}
			if (visualID == RefTransitionEditPart.VISUAL_ID) {
				result.add(new PNMLCoreModelNodeDescriptor(childElement,
						visualID));
				continue;
			}
		}
		for (Iterator it = modelElement.getPageLabelProxy().iterator(); it
				.hasNext();) {
			PageLabelProxy childElement = (PageLabelProxy) it.next();
			int visualID = PNMLCoreModelVisualIDRegistry.getNodeVisualID(view,
					childElement);
			if (visualID == PageLabelProxyEditPart.VISUAL_ID) {
				result.add(new PNMLCoreModelNodeDescriptor(childElement,
						visualID));
				continue;
			}
		}
		Resource resource = modelElement.eResource();
		for (Iterator semanticIterator = getPhantomNodesIterator(resource); semanticIterator
				.hasNext();) {
			EObject childElement = (EObject) semanticIterator.next();
			if (childElement == modelElement) {
				continue;
			}
			if (PNMLCoreModelVisualIDRegistry.getNodeVisualID(view,
					childElement) == LabelProxyEditPart.VISUAL_ID) {
				// eki inserted additional condition so that phantom nodes only show
				//     up when they are not assigned to a page yet or when they
				//     are attached to an object on this page (modelElement).	
				// TODO This interferes significantly with the automatic re-generation of
				//      the GMF-editor and needs therefore be done in better way (one way would
				//      be to let the method as generated and afterwards remove the non-relevant
				//      ProxyLabels from the list again -- an even better way would be to
				//      change the getPhantomNodesIterator(); but this method unfortunately
				//      does not pass the modelElement/ page that is needed for this selection).
				EObject container = childElement.eContainer();
				if (container == null
						|| (container instanceof Object && container
								.eContainer() == modelElement)) {
					result.add(new PNMLCoreModelNodeDescriptor(childElement,
							LabelProxyEditPart.VISUAL_ID));
					continue;
				}
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Iterator getPhantomNodesIterator(Resource resource) {
		return resource.getAllContents();
	}

	/**
	 * @generated
	 */
	public static List getContainedLinks(View view) {
		switch (PNMLCoreModelVisualIDRegistry.getVisualID(view)) {
		case PageEditPart.VISUAL_ID:
			return getPage_1000ContainedLinks(view);
		case PlaceEditPart.VISUAL_ID:
			return getPlace_2001ContainedLinks(view);
		case RefPlaceEditPart.VISUAL_ID:
			return getRefPlace_2002ContainedLinks(view);
		case TransitionEditPart.VISUAL_ID:
			return getTransition_2003ContainedLinks(view);
		case Page2EditPart.VISUAL_ID:
			return getPage_2004ContainedLinks(view);
		case RefTransitionEditPart.VISUAL_ID:
			return getRefTransition_2005ContainedLinks(view);
		case LabelProxyEditPart.VISUAL_ID:
			return getLabelProxy_2009ContainedLinks(view);
		case PageLabelProxyEditPart.VISUAL_ID:
			return getPageLabelProxy_2008ContainedLinks(view);
		case ArcEditPart.VISUAL_ID:
			return getArc_4001ContainedLinks(view);
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getIncomingLinks(View view) {
		switch (PNMLCoreModelVisualIDRegistry.getVisualID(view)) {
		case PlaceEditPart.VISUAL_ID:
			return getPlace_2001IncomingLinks(view);
		case RefPlaceEditPart.VISUAL_ID:
			return getRefPlace_2002IncomingLinks(view);
		case TransitionEditPart.VISUAL_ID:
			return getTransition_2003IncomingLinks(view);
		case Page2EditPart.VISUAL_ID:
			return getPage_2004IncomingLinks(view);
		case RefTransitionEditPart.VISUAL_ID:
			return getRefTransition_2005IncomingLinks(view);
		case LabelProxyEditPart.VISUAL_ID:
			return getLabelProxy_2009IncomingLinks(view);
		case PageLabelProxyEditPart.VISUAL_ID:
			return getPageLabelProxy_2008IncomingLinks(view);
		case ArcEditPart.VISUAL_ID:
			return getArc_4001IncomingLinks(view);
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getOutgoingLinks(View view) {
		switch (PNMLCoreModelVisualIDRegistry.getVisualID(view)) {
		case PlaceEditPart.VISUAL_ID:
			return getPlace_2001OutgoingLinks(view);
		case RefPlaceEditPart.VISUAL_ID:
			return getRefPlace_2002OutgoingLinks(view);
		case TransitionEditPart.VISUAL_ID:
			return getTransition_2003OutgoingLinks(view);
		case Page2EditPart.VISUAL_ID:
			return getPage_2004OutgoingLinks(view);
		case RefTransitionEditPart.VISUAL_ID:
			return getRefTransition_2005OutgoingLinks(view);
		case LabelProxyEditPart.VISUAL_ID:
			return getLabelProxy_2009OutgoingLinks(view);
		case PageLabelProxyEditPart.VISUAL_ID:
			return getPageLabelProxy_2008OutgoingLinks(view);
		case ArcEditPart.VISUAL_ID:
			return getArc_4001OutgoingLinks(view);
		}
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getPage_1000ContainedLinks(View view) {
		Page modelElement = (Page) view.getElement();
		List result = new LinkedList();
		result.addAll(getContainedTypeModelFacetLinks_Arc_4001(modelElement));
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Object_Labelproxy_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getPlace_2001ContainedLinks(View view) {
		Place modelElement = (Place) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Object_Labelproxy_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getRefPlace_2002ContainedLinks(View view) {
		RefPlace modelElement = (RefPlace) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Object_Labelproxy_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getTransition_2003ContainedLinks(View view) {
		Transition modelElement = (Transition) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Object_Labelproxy_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getPage_2004ContainedLinks(View view) {
		Page modelElement = (Page) view.getElement();
		List result = new LinkedList();
		result.addAll(getContainedTypeModelFacetLinks_Arc_4001(modelElement));
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Object_Labelproxy_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getRefTransition_2005ContainedLinks(View view) {
		RefTransition modelElement = (RefTransition) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Object_Labelproxy_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getLabelProxy_2009ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getPageLabelProxy_2008ContainedLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getArc_4001ContainedLinks(View view) {
		Arc modelElement = (Arc) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Object_Labelproxy_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getPlace_2001IncomingLinks(View view) {
		Place modelElement = (Place) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result.addAll(getIncomingTypeModelFacetLinks_Arc_4001(modelElement,
				crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getRefPlace_2002IncomingLinks(View view) {
		RefPlace modelElement = (RefPlace) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result.addAll(getIncomingTypeModelFacetLinks_Arc_4001(modelElement,
				crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getTransition_2003IncomingLinks(View view) {
		Transition modelElement = (Transition) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result.addAll(getIncomingTypeModelFacetLinks_Arc_4001(modelElement,
				crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getPage_2004IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getRefTransition_2005IncomingLinks(View view) {
		RefTransition modelElement = (RefTransition) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result.addAll(getIncomingTypeModelFacetLinks_Arc_4001(modelElement,
				crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getLabelProxy_2009IncomingLinks(View view) {
		LabelProxy modelElement = (LabelProxy) view.getElement();
		Map crossReferences = EcoreUtil.CrossReferencer.find(view.eResource()
				.getResourceSet().getResources());
		List result = new LinkedList();
		result.addAll(getIncomingFeatureModelFacetLinks_Object_Labelproxy_4003(
				modelElement, crossReferences));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getPageLabelProxy_2008IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getArc_4001IncomingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getPlace_2001OutgoingLinks(View view) {
		Place modelElement = (Place) view.getElement();
		List result = new LinkedList();
		result.addAll(getOutgoingTypeModelFacetLinks_Arc_4001(modelElement));
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Object_Labelproxy_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getRefPlace_2002OutgoingLinks(View view) {
		RefPlace modelElement = (RefPlace) view.getElement();
		List result = new LinkedList();
		result.addAll(getOutgoingTypeModelFacetLinks_Arc_4001(modelElement));
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Object_Labelproxy_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getTransition_2003OutgoingLinks(View view) {
		Transition modelElement = (Transition) view.getElement();
		List result = new LinkedList();
		result.addAll(getOutgoingTypeModelFacetLinks_Arc_4001(modelElement));
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Object_Labelproxy_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getPage_2004OutgoingLinks(View view) {
		Page modelElement = (Page) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Object_Labelproxy_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getRefTransition_2005OutgoingLinks(View view) {
		RefTransition modelElement = (RefTransition) view.getElement();
		List result = new LinkedList();
		result.addAll(getOutgoingTypeModelFacetLinks_Arc_4001(modelElement));
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Object_Labelproxy_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	public static List getLabelProxy_2009OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getPageLabelProxy_2008OutgoingLinks(View view) {
		return Collections.EMPTY_LIST;
	}

	/**
	 * @generated
	 */
	public static List getArc_4001OutgoingLinks(View view) {
		Arc modelElement = (Arc) view.getElement();
		List result = new LinkedList();
		result
				.addAll(getOutgoingFeatureModelFacetLinks_Object_Labelproxy_4003(modelElement));
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getContainedTypeModelFacetLinks_Arc_4001(
			Page container) {
		Collection result = new LinkedList();
		for (Iterator links = container.getObject().iterator(); links.hasNext();) {
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof Arc) {
				continue;
			}
			Arc link = (Arc) linkObject;
			if (ArcEditPart.VISUAL_ID != PNMLCoreModelVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			Node dst = link.getTarget();
			Node src = link.getSource();
			result.add(new PNMLCoreModelLinkDescriptor(src, dst, link,
					PNMLCoreModelElementTypes.Arc_4001, ArcEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getIncomingTypeModelFacetLinks_Arc_4001(
			Node target, Map crossReferences) {
		Collection result = new LinkedList();
		Collection settings = (Collection) crossReferences.get(target);
		for (Iterator it = settings.iterator(); it.hasNext();) {
			EStructuralFeature.Setting setting = (EStructuralFeature.Setting) it
					.next();
			if (setting.getEStructuralFeature() != PnmlcoremodelPackage.eINSTANCE
					.getArc_Target()
					|| false == setting.getEObject() instanceof Arc) {
				continue;
			}
			Arc link = (Arc) setting.getEObject();
			if (ArcEditPart.VISUAL_ID != PNMLCoreModelVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			Node src = link.getSource();
			result.add(new PNMLCoreModelLinkDescriptor(src, target, link,
					PNMLCoreModelElementTypes.Arc_4001, ArcEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getIncomingFeatureModelFacetLinks_Object_Labelproxy_4003(
			LabelProxy target, Map crossReferences) {
		Collection result = new LinkedList();
		Collection settings = (Collection) crossReferences.get(target);
		for (Iterator it = settings.iterator(); it.hasNext();) {
			EStructuralFeature.Setting setting = (EStructuralFeature.Setting) it
					.next();
			if (setting.getEStructuralFeature() == PnmlcoremodelPackage.eINSTANCE
					.getObject_Labelproxy()) {
				result.add(new PNMLCoreModelLinkDescriptor(
						setting.getEObject(), target,
						PNMLCoreModelElementTypes.ObjectLabelproxy_4003,
						ObjectLabelproxyEditPart.VISUAL_ID));
			}
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getOutgoingTypeModelFacetLinks_Arc_4001(
			Node source) {
		Page container = null;
		// Find container element for the link.
		// Climb up by containment hierarchy starting from the source
		// and return the first element that is instance of the container class.
		for (EObject element = source; element != null && container == null; element = element
				.eContainer()) {
			if (element instanceof Page) {
				container = (Page) element;
			}
		}
		if (container == null) {
			return Collections.EMPTY_LIST;
		}
		Collection result = new LinkedList();
		for (Iterator links = container.getObject().iterator(); links.hasNext();) {
			EObject linkObject = (EObject) links.next();
			if (false == linkObject instanceof Arc) {
				continue;
			}
			Arc link = (Arc) linkObject;
			if (ArcEditPart.VISUAL_ID != PNMLCoreModelVisualIDRegistry
					.getLinkWithClassVisualID(link)) {
				continue;
			}
			Node dst = link.getTarget();
			Node src = link.getSource();
			if (src != source) {
				continue;
			}
			result.add(new PNMLCoreModelLinkDescriptor(src, dst, link,
					PNMLCoreModelElementTypes.Arc_4001, ArcEditPart.VISUAL_ID));
		}
		return result;
	}

	/**
	 * @generated
	 */
	private static Collection getOutgoingFeatureModelFacetLinks_Object_Labelproxy_4003(
			Object source) {
		Collection result = new LinkedList();
		for (Iterator destinations = source.getLabelproxy().iterator(); destinations
				.hasNext();) {
			LabelProxy destination = (LabelProxy) destinations.next();
			result.add(new PNMLCoreModelLinkDescriptor(source, destination,
					PNMLCoreModelElementTypes.ObjectLabelproxy_4003,
					ObjectLabelproxyEditPart.VISUAL_ID));
		}
		return result;
	}

}
